edu.sc.seis.sod.validator.model

## Interface Form

- All Superinterfaces:
    FormProvider
  All Known Subinterfaces:
    GenitorForm, MultigenitorForm
  All Known Implementing Classes:
    AbstractForm, AbstractGenitorForm, AbstractMultigenitorForm, AnyXMLElement, Attribute, Choice, Data, DataList, Empty, Group, Interleave, NamedElement, NotAllowed, Text, Value

      public interface Form
      extends FormProvider

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Tourist v)`
    `Form` | `deref(Form parent, Definition def)`
    `Annotation` | `getAnnotation()`
    `Definition` | `getDef()`
    `java.lang.String` | `getNamespace()`
    `Form` | `getParent()`
    `java.lang.String` | `getXPath()`
    `boolean` | `isAncestorOf(Form f)`
    `boolean` | `isAncestorOf(Form f, Form root)`
    `boolean` | `isFromDef()`

    - ### Methods inherited from interface edu.sc.seis.sod.validator.model.FormProvider

      `copyWithNewParent, getForm, getMax, getMin, setAnnotation, setMax, setMin`

- - ### Method Detail

    - #### getXPath

          java.lang.String getXPath()

    - #### getAnnotation

          Annotation getAnnotation()

    - #### getParent

          Form getParent()

      Returns:
        the Form containing this Form. Every Form has a parent except for the root which returns null

    - #### isFromDef

          boolean isFromDef()

      Returns:
        true if this From is originally from a Definition. If true, getDef() will return this Form's definition

    - #### getDef

          Definition getDef()

      Returns:
        the definition this form was originally contained in. Null if this form was not contained in a definition

    - #### getNamespace

          java.lang.String getNamespace()

      Returns:
        the namespace of this form

    - #### isAncestorOf

          boolean isAncestorOf(Form f)

      Returns:
        true if the passed in Form is directly descended from this Form

    - #### isAncestorOf

          boolean isAncestorOf(Form f,
                               Form root)

    - #### deref

          Form deref(Form parent,
                     Definition def)

      Returns:
        this form set with parent as its parent, isFromDef returns true and getDef returns def

    - #### accept

          void accept(Tourist v)